/*
Crafter®.Graphics
Copyright (C) 2026 Catcrafts®
Catcrafts.net

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 3.0 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
*/

module;
#define STB_TRUETYPE_IMPLEMENTATION
#include "../lib/stb_truetype.h"
module Crafter.Graphics:Font_impl;
import :Font;
import std;

using namespace Crafter;

Font::Font(const std::filesystem::path& fontFilePath) {
    // 1. Load the font file into memory
    std::ifstream fontFile(fontFilePath, std::ios::binary | std::ios::ate);
    if (!fontFile.is_open()) {
        std::cerr << "Failed to open font file\n";
    }

    std::streamsize size = fontFile.tellg();
    fontFile.seekg(0, std::ios::beg);
    fontBuffer.resize(size);
    if (!fontFile.read((char*)fontBuffer.data(), size)) {
        std::cerr << "Failed to read font file\n";
    }

    // 2. Initialize the font
    if (!stbtt_InitFont(&font, fontBuffer.data(), stbtt_GetFontOffsetForIndex(fontBuffer.data(), 0))) {
        std::cout << "Test6" << std::endl;
        std::cerr << "Failed to initialize font.\n";
    }

    int ascent;
    int descent;
    int lineGap;

    stbtt_GetFontVMetrics(&font, &ascent, &descent, &lineGap);

    this->ascent = ascent;
    this->descent = descent;
    this->lineGap = lineGap;
}

std::uint32_t Font::GetLineWidth(const std::string_view text, float size) {
    float scale = stbtt_ScaleForPixelHeight(&font, size);
    std::uint32_t lineWidth = 0;
    std::size_t i = 0;
    while (i < text.size()) {
        std::uint32_t cp = DecodeUtf8(text, i);
        if (cp == 0) break;
        int advance, lsb;
        stbtt_GetCodepointHMetrics(&font, static_cast<int>(cp), &advance, &lsb);
        lineWidth += (int)(advance * scale);
    }
    return lineWidth;
}

float Font::LineHeight(float size) {
    float scale = stbtt_ScaleForPixelHeight(&font, size);
    return (ascent - descent + lineGap) * scale;
}

float Font::AscentPx(float size) {
    return ascent * stbtt_ScaleForPixelHeight(&font, size);
}

float Font::ScaleForSize(float size) {
    return stbtt_ScaleForPixelHeight(&font, size);
}